 <!DOCTYPE html>
 <html>
 <head>
  <meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
  <style type="text/css">
    html { height: 100% }
    body { height: 100%; margin: 0; padding: 0 }
    #map { height: 90%; width: 90% }
  </style>

  <script src="https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&libraries=geometry"></script>
  <script type ="text/javascript" src="http://www.geocodezip.com/scripts/v3_epoly.js"></script> 
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>   
  <script type="text/javascript">
    var iconBase = 'https://web.cs.dal.ca/~jayaraman/'; //Base URL to for the folder in which START/STOP and Boat icons are stored. 

    var line;
    var cont = [];
    var map;
    var jStop = false;
    var pointDistances;
    var marker;
    var mark; 
    var gmarker = [];
    var timers = [];
    var wholeDist;
    var previewInterval = 1000;  
    var previewSpeed = 100;
    var end = new google.maps.LatLng(34.205299, -77.799957);
    var pointZero = new google.maps.LatLng(34.2044814, -77.801652);
    var markerCluster;
    var string_gen = [];

    //step and tick are the control variables responsible for marker animation. 
    var step = 0.5; // 5; // metres. The marker moves 5 meters on each iteration
    var tick = 1000; // milliseconds 
    var eol;
    var k=0;
    var stepnum=0;
    var speed = "";
    var lastVertex = 1;
    var stepsp = [];

    //Values retrieved from the Database
    var athlete_name = []; 
    var bib_number = [];
    var age_group = [];
    var gender = [];
    var craft = [];
    var division = [];
    var placing = [];
    var time_sec = [];
    var no_user;

    //Database connection variables
    var gjson ;
    var cont = [];
    gjson = getJSON('http://localhost/a.php') ;
    var obj = JSON.parse(gjson);

    //JSON parsing
    for (var i = 0; i < obj.length; i++) {

      var selected_object = obj[i];
      var sel_name = selected_object['Athelete_Name'];
      athlete_name.push(sel_name);

      var sel_bibno = selected_object['Bib_Number'];
      bib_number.push(sel_bibno);

      var sel_agegroup = selected_object['Age_Group'];
      age_group.push(sel_agegroup);

      var sel_gender = selected_object['Gender'];
      gender.push(sel_gender);

      var sel_craft = selected_object['Craft'];
      craft.push(sel_craft);

      var sel_division = selected_object['Division'];
      division.push(sel_division);

      var sel_placing = selected_object['Final_Placing'];
      placing.push(sel_placing);

      var sel_time = selected_object['Time_sec'];
      time_sec.push(sel_time);

    }

    //Content for InfoWindow
    for (var i = 0; i < time_sec.length; i++) {
      var slashn = '\n';
      var conca = athlete_name[i].concat(bib_number[i],slashn,age_group[i],slashn,gender[i],slashn,craft[i]);
      cont.push(conca);
    }
    console.log(string_gen);
    no_user = athlete_name.length;

    for (var i = 0; i < time_sec.length; i++) {
        var temp_stepsp = time_sec[i]/1000; //Velocity calculation in m/s (1000ms = 1s)
        stepsp.push(temp_stepsp);

      }

      //Initialize is used to load the map with the markers and polyline
      function initialize() {
        var mapOptions = {
          center: new google.maps.LatLng(34.2044814, -77.801652),
          zoom:12,
          mapTypeId: google.maps.MapTypeId.ROADMAP
        };

        map = new google.maps.Map(document.getElementById('map'), mapOptions);

        var lineCoordinates = [
        new google.maps.LatLng(34.2044814, -77.801652),
        new google.maps.LatLng(34.207996, -77.806072),
        new google.maps.LatLng(34.210516, -77.804913),
        new google.maps.LatLng(34.214597, -77.811157),
        new google.maps.LatLng(34.2174314, -77.815154), 
        new google.maps.LatLng(34.2202614, -77.812118),
        new google.maps.LatLng(34.2189044, -77.808717),
        new google.maps.LatLng(34.2180704, -77.807451),
        new google.maps.LatLng(34.2192814, -77.797285),
        new google.maps.LatLng(34.218668, -77.794153),
        new google.maps.LatLng(34.205299, -77.799957)
        ];

        map.setCenter(lineCoordinates[4]);

    // point distances from beginning in %
    var sphericalLib = google.maps.geometry.spherical;
    pointDistances = [];

    //To calculate the distance between the start and end points.
    for (var i = 0; i < lineCoordinates.length-1; i++) {
        wholeDist = sphericalLib.computeDistanceBetween(
        lineCoordinates[i],
        lineCoordinates[i+1]);
    }

    for (var i = 0; i < lineCoordinates.length; i++) {
      pointDistances[i] = 100 * sphericalLib.computeDistanceBetween(
        lineCoordinates[i], pointZero) / wholeDist;
    }


    var icons = {
      start: {
        icon: iconBase + 'start.png' //Start icon
      },
      end: {
        icon: iconBase + 'end.png'  //End icon
      }
    };    

    var features = [
    {
      position: new google.maps.LatLng(34.2044814, -77.801652),
      type: 'start'
    },
    {
      position: new google.maps.LatLng(34.205299, -77.799957),
      type: 'end'
    }
    ];

    features.forEach(function(feature) {
     marker = new google.maps.Marker({
      position: feature.position,
      icon: icons[feature.type].icon,
      map: map
    });
   });

    //Marker cluster 
    var markerClusterer = new MarkerClusterer(map, [], {
      maxZoom: 10,
      gridSize: 10,
      imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m1.png'
    });

    //Marker creation
    for(i = 0; i<no_user ; i++) {
     marker = new google.maps.Marker({
      position: pointZero,
      icon: new google.maps.MarkerImage("http://maps.google.com/mapfiles/ms/icons/yellow-dot.png"),
      map: map
    });
     marker.content = cont[i];
     gmarker.push(marker);
     console.log(gmarker.length);

     markerCluster = new MarkerClusterer(map, gmarker, {imagePath:'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m1.png'});
   }

   //Creating polyline instance
   polyline = new google.maps.Polyline({
    path: lineCoordinates,
    strokeColor: '#FF0000',
    strokeOpacity: 1.0,
    strokeWeight: 2,
    icons: [{
      icon: icons.boat,
      offset: '100%'
    }],
    map: map
  });
   map.setZoom(14);
   animateIcon(0,0,10000);
 }

 
 function animateIcon(i, offset, totalDistance) {
        var newOffset = (offset + previewSpeed * 1000) % totalDistance;   
        var pos = google.maps.geometry.spherical.computeOffset(pointZero, newOffset, google.maps.geometry.spherical.computeHeading(pointZero,end));
        gmarker[i].setPosition(pos);

        timers[i] = setTimeout(function () {           // we trigger this function again in 1 second
          animateIcon(i, newOffset, totalDistance)
        }, previewInterval
        );
      }  

//=============== animation functions ======================
function updatePoly(d) {
        // Spawn a new polyline every 20 vertices, because updating a 100-vertex poly is too slow
        if (poly2.getPath().getLength() > 20) {
          poly2=new google.maps.Polyline([polyline.getPath().getAt(lastVertex-1)]);
        }

        if (polyline.GetIndexAtDistance(d) < lastVertex+2) {
         if (poly2.getPath().getLength()>1) {
           poly2.getPath().removeAt(poly2.getPath().getLength()-1)
         }
         poly2.getPath().insertAt(poly2.getPath().getLength(),polyline.GetPointAtDistance(d));
       } else {
        poly2.getPath().insertAt(poly2.getPath().getLength(),end);
      }
    }

    function stopAnimation() {
      jStop = true;
      stop();

    }

    //Starting point for animation functions - animate(distanceToBeMoved, markerInstanceToBeMoved)
    function animate(d,marker) {
      if (d>eol) {
        map.panTo(end);
        marker.setPosition(end);
        return;
      }
      var p = polyline.GetPointAtDistance(d);
      map.panTo(p);
      marker.setPosition(p);
      updatePoly(d);
      var de = d+step;
      if (!jStop) {
        timerHandle = setTimeout(function() {
        animate(de,marker); // decrement and run ourselves again
      }, tick);
      }
    }


    function startAnimation() {

      eol=polyline.Distance();
      map.setCenter(polyline.getPath().getAt(0));
      poly2 = new google.maps.Polyline({path: [polyline.getPath().getAt(0)], strokeColor:"#0000FF", strokeWeight:10});

      setTimeout(function() {
        for (var i = 0; i < gmarker.length; i++) {
            // console.log(i);
            animate(stepsp[i],gmarker[i]);

            var infowindow = new google.maps.InfoWindow();  
            google.maps.event.addListener(gmarker[i], 'click', (function(marker) {  
             return function() {    
               infowindow.setContent(marker.content);  
               infowindow.open(map,this);  
             }  
           })(marker));  
          }
        }, tick);
    }
    google.maps.event.addDomListener(window, 'load', initialize);
    function getJSON(url) {
      var resp ;
      var xmlHttp ;

      resp  = '' ;
      xmlHttp = new XMLHttpRequest();

      if(xmlHttp != null)
      {
        xmlHttp.open( "GET", url, false );
        xmlHttp.send( null );
        resp = xmlHttp.responseText;
      }

      return resp ;
    }
  </script>
</head>

<body>

  <div id='map'></div>
  <input type="submit" value="start"  onclick="calltime()" id = "start"/>
  <input type="button" onclick="stop_timer()" value="stop"  id = "stop"/>
  <input type="button" onclick="reset()" value="reset" />
  <label id="hours">00</label>:<label id="minutes">00</label>:<label id="seconds">00</label>
  <script type="text/javascript">
    var hoursLabel = document.getElementById("hours");
    var minutesLabel = document.getElementById("minutes");
    var secondsLabel = document.getElementById("seconds");
    var totalSeconds = 0;
    var timer;
    function calltime()
    {
      startAnimation();
      timer = setInterval(setTime, 1000);
    }

    //Count up timer 
    function setTime()
    {
      ++totalSeconds;
      var totalMin = totalSeconds/60;
      secondsLabel.innerHTML = pad(totalSeconds%60);
      minutesLabel.innerHTML = pad(parseInt(totalSeconds/60));
      hoursLabel.innerHTML = pad(parseInt(totalMin/60));
    }
    function stop_timer() {
      document.getElementById("stop").disabled = true;
      document.getElementById("start").disabled = true;
      stopAnimation();
      if (timer) {
        clearInterval(timer);
        timer = null;
        secondsLabel.innerHTML = '00';
        minutesLabel.innerHTML = '00';
        hoursLabel.innerHTML = '00';

      }
    };

    function reset() {
      calltime();
      if (timer) {
        totalSeconds = 0;
      }
      location.reload();
    };
    function pad(val)
    {
      var valString = val + "";
      if(valString.length < 2)
      {
        return "0" + valString;
      }
      else
      {
        return valString;
      }
    }
  </script>
  <script src="https://cdn.rawgit.com/googlemaps/js-marker-clusterer/gh-pages/src/markerclusterer.js"></script>
</body>
</html>